package com.amqp.shanxi.dao;

import com.amqp.shanxi.model.*;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Select;

import java.util.List;

@Mapper
public interface AlarmInfoDao {


    /**
     * 干滩实时数据
     */
    @Select("SELECT c.gantanid AS sensorno, c.jctime AS warningdata, c.gantan AS value, c.ifbj AS warninglevel, b.id AS recordid FROM (" +
            " SELECT a.id, a.gantanid, a.jctime, a.gantan, a.bagao, a.podu, a.ifbj from (" +
            " SELECT id, gantanid, jctime, gantan, bagao, podu, ifbj, rank() OVER (PARTITION BY gantanid ORDER BY jctime DESC)" +
            " FROM tab_gantanweiyi where jctime > now() - INTERVAL '6 hour'" +
            " ) a WHERE rank = 1 and ifbj = '1'" +
            " ) c INNER JOIN (SELECT id, name FROM tab_sensor) b on c.gantanid = b.name")
    List<GantanAlarmInfoModel> findGantanAlarmData();


    @Select("SELECT c.sensorname AS sensorno, c.jctime AS warningdata, c.value2 as value, c.ifbj AS warninglevel, b.id AS recordid FROM (" +
            " SELECT a.id, a.sensorname, a.jctime, a.value2, a.ifbj FROM (" +
            " SELECT id, sensorname, jctime, value2, ifbj, rank() OVER (PARTITION BY sensorname ORDER BY jctime DESC)"+
            " FROM tab_kushuiwei WHERE jctime > now() - INTERVAL '6 hour'" +
            " ) a WHERE rank = 1 and ifbj = '1'" +
            " ) c INNER JOIN (SELECT id, name FROM tab_sensor) b ON c.sensorname = b.name")
    List<KushuiweiAlarmInfoModel> findKushuiweiAlarmData();


    @Select("SELECT c.sensorname AS sensorno, c.jctime AS warningdata, c.disx AS value, c.ifbj AS warninglevel, b.id AS recordid FROM (" +
            " SELECT a.id, a.sensorname, a.jctime, a.disx, a.disy, a.disz, a.ifbj from (" +
            " SELECT id, sensorname, jctime, disx, disy, disz, ifbj, rank() OVER (PARTITION BY sensorname ORDER BY jctime DESC)" +
            " FROM tab_batidibiaoweiyi where jctime > now() - INTERVAL '6 hour'" +
            " ) a WHERE rank = 1 and ifbj = '1'" +
            " ) c INNER JOIN (SELECT id, name FROM tab_sensor) b on c.sensorname = b.name")
    List<BiaomianweiyiAlarmInfoModel> findBiaomianweiyiAlarmData();


    @Select("select c.sensorname AS sensorno, c.jctime AS warningdata, c.value2 as value, c.ifbj AS warninglevel, b.id AS recordid from ("+
            " select a.id, a.sensorname, a.jctime, a.value2, a.ifbj from (" +
            " select id, sensorname, jctime, value2, ifbj, rank() over (partition by sensorname order by jctime desc)" +
            " from tab_jinrunxian where jctime > now() - interval '6 hour'" +
            " ) a where rank = 1 and ifbj = '1'" +
            " ) c  inner join (select id, name from tab_sensor) b on c.sensorname = b.name")
    List<JinrunxianAlarmInfoModel> findJinrunxianAlarmData();


    @Select("select c.sensorname AS sensorno, c.jctime AS warningdata, c.value2 as value, c.ifbj AS warninglevel, b.id AS recordid from (" +
            " select a.id, a.sensorname, a.jctime, a.value2, a.ifbj from (" +
            " select id, sensorname, jctime, value2, ifbj, rank() over (partition by sensorname order by jctime desc)" +
            " from tab_jiangyuliang where jctime > now() - interval '6 hour'" +
            " ) a where rank = 1 and ifbj = '1'" +
            " ) c  inner join (select id, name from tab_sensor) b on c.sensorname = b.name")
    List<JiangyuliangAlarmInfoModel> findJiangyuliangAlarmData();


    // 监测项报警
    @Select("select a.mark AS itemno,b.id AS recordid, b.yjjb AS rwarninglevel, b.jctime AS warningdata from"+
            " (select mark from tab_sensor group by mark) a left join" +
            " (select id, alarmtype, yjjb, jctime from tab_alarmtype where status = 0) b on a.mark = b.alarmtype where b.jctime is not null")
    List<DeviceAlarmInfoModel> findDeviceAlarmData();


    @Select("select alarmname as warningcontent, jctime AS collectdate, yjjb AS rwarninglevel from tab_alarmtype where status = 0")
    List<WkkAlarmTimeInfoModel> findWkkAlarmData();


    @Select("select c.sensorname AS sensorno, c.jctime AS warningdata, c.value2 as value, c.ifbj AS warninglevel, b.id AS recordid from (" +
            " select a.id, a.sensorname, a.jctime, a.value2, a.ifbj from ("+
            " select id, sensorname, jctime, value2, ifbj, rank() over (partition by sensorname order by jctime desc)"+
            " from tab_shuipingweiyi where jctime > now() - interval '6 hour'" +
            " ) a where rank = 1 and ifbj = '1'" +
            " ) c  inner join (select id, name from tab_sensor) b on c.sensorname = b.name")
    List<NeibuweiyiAlarmInfoModel> findNeibushuipingAlarmData();


    @Select("select c.sensorname AS sensorno, c.jctime AS warningdata, c.value2 as value, c.ifbj AS warninglevel, b.id AS recordid from (" +
            " select a.id, a.sensorname, a.jctime, a.value2, a.ifbj from (" +
            " select id, sensorname, jctime, value2, ifbj, rank() over (partition by sensorname order by jctime desc)" +
            " from tab_neibuchenjiang where jctime > now() - interval '6 hour'" +
            " ) a where rank = 1 and ifbj = '1'" +
            " ) c  inner join (select id, name from tab_sensor) b on c.sensorname = b.name")
    List<NeibuweiyiAlarmInfoModel> findNeibuchenjiangAlarmData();

}
