package com.amqp.shanxi.dao;

import com.amqp.shanxi.model.*;
import lombok.Data;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Select;

import java.util.List;

@Mapper
public interface RealTimeInfoDao {


    /**
     * 干滩实时数据
     */
    @Select("SELECT c.gantanid AS sensorno, c.jctime AS collectdate, c.gantan AS value, c.bagao AS beachTopHeight, c.podu AS beachLongSlope, c.ifbj AS valuestate, b.id AS recordid FROM (" +
            " SELECT a.id, a.gantanid, a.jctime, a.gantan, a.bagao, a.podu, a.ifbj from (" +
            " SELECT id, gantanid, jctime, gantan, bagao, podu, ifbj, rank() OVER (PARTITION BY gantanid ORDER BY jctime DESC)" +
            " FROM tab_gantanweiyi where jctime > now() - INTERVAL '6 hour'" +
            " ) a WHERE rank = 1" +
            " ) c INNER JOIN (SELECT id, name FROM tab_sensor) b on c.gantanid = b.name")
    List<GantanRealTimeInfoModel> findGantanRealTimeData();


    @Select("SELECT c.sensorname AS sensorno, c.jctime AS collectdate, c.value2 as value, c.ifbj AS valuestate, b.id AS recordid FROM (" +
            " SELECT a.id, a.sensorname, a.jctime, a.value2, a.ifbj FROM (" +
            " SELECT id, sensorname, jctime, value2, ifbj, rank() OVER (PARTITION BY sensorname ORDER BY jctime DESC)"+
            " FROM tab_kushuiwei WHERE jctime > now() - INTERVAL '6 hour'" +
            " ) a WHERE rank = 1" +
            " ) c INNER JOIN (SELECT id, name FROM tab_sensor) b ON c.sensorname = b.name")
    List<KushuiweiRealTimeInfoModel> findKushuiweiRealTimeData();


    @Select("SELECT c.sensorname AS sensorno, c.jctime AS collectdate, c.disx AS xvalue, c.disy AS yvalue, c.disz AS zvalue, c.ifbj AS displacementstate, b.id AS recordid FROM (" +
            " SELECT a.id, a.sensorname, a.jctime, a.disx, a.disy, a.disz, a.ifbj from (" +
            " SELECT id, sensorname, jctime, disx, disy, disz, ifbj, rank() OVER (PARTITION BY sensorname ORDER BY jctime DESC)" +
            " FROM tab_batidibiaoweiyi where jctime > now() - INTERVAL '6 hour'" +
            " ) a WHERE rank = 1" +
            " ) c INNER JOIN (SELECT id, name FROM tab_sensor) b on c.sensorname = b.name")
    List<BiaomianweiyiRealTimeInfoModel> findBiaomianweiyiRealTimeData();


    @Select("select c.sensorname AS sensorno, c.jctime AS collectdate, c.value2 as value, c.ifbj AS valuestate, b.id AS recordid from ("+
            " select a.id, a.sensorname, a.jctime, a.value2, a.ifbj from (" +
            " select id, sensorname, jctime, value2, ifbj, rank() over (partition by sensorname order by jctime desc)" +
            " from tab_jinrunxian where jctime > now() - interval '6 hour'" +
            " ) a where rank = 1" +
            " ) c  inner join (select id, name from tab_sensor) b on c.sensorname = b.name")
    List<JinrunxianRealTimeInfoModel> findJinrunxianRealTimeData();


    @Select("select c.sensorname AS sensorno, c.jctime AS collectdate, c.value2 as value, c.ifbj AS onehourvaluestate, b.id AS recordid from (" +
            " select a.id, a.sensorname, a.jctime, a.value2, a.ifbj from (" +
            " select id, sensorname, jctime, value2, ifbj, rank() over (partition by sensorname order by jctime desc)" +
            " from tab_jiangyuliang where jctime > now() - interval '6 hour'" +
            " ) a where rank = 1" +
            " ) c  inner join (select id, name from tab_sensor) b on c.sensorname = b.name")
    List<JiangyuliangRealTimeInfoModel> findJiangyuliangRealTimeData();


    // 监测项报警
    @Select("select a.mark AS itemno,b.id AS recordid, b.yjjb AS state, b.jctime AS collectdate from"+
            " (select mark from tab_sensor group by mark) a left join" +
            " (select id, alarmtype, yjjb, jctime from tab_alarmtype where status = 0) b on a.mark = b.alarmtype")
    List<DeviceRealTimeInfoModel> findDeviceRealTimeData();


    @Select("select jctime AS collectdate, yjjb AS state from tab_alarmtype where status = 0")
    List<WkkRealTimeInfoModel> findWkkRealTimeData();

    /**
     * 设备离线
     * @return
     */
    @Select("select b.id AS recordid, b.name, a.jctime from" +
            " (select jctime, gantanid from tab_gantanweiyi where jctime > now() - interval '6 hour') a right join" +
            " (select id, name from tab_sensor where mark = '干滩2') b on a.gantanid = b.name where jctime is null" +
            " union all" +
            " select  b.id AS recordid, b.name, a.jctime from" +
            " (select sensorname, jctime from tab_kushuiwei where jctime > now() - interval '6 hour') a right join" +
            " (select id, name from tab_sensor where mark = '库水位') b on a.sensorname = b.name where a.jctime is null" +
            " union all" +
            " select  b.id AS recordid, b.name, a.jctime from" +
            " (select sensorname, jctime from tab_batidibiaoweiyi where jctime > now() - interval '6 hour') a right join" +
            " (select id, name from tab_sensor where mark = '坝体表面位移') b on a.sensorname = b.name where a.jctime is null" +
            " union all"+
            " select  b.id AS recordid, b.name, a.jctime from" +
            " (select sensorname, jctime from tab_jinrunxian where jctime > now() - interval '6 hour') a right join" +
            " (select id, name from tab_sensor where mark = '浸润线') b on a.sensorname = b.name where a.jctime is null" +
            " union all" +
            " select  b.id AS recordid, b.name, a.jctime from" +
            " (select sensorname, jctime from tab_jiangyuliang where jctime > now() - interval '6 hour') a right join" +
            " (select id, name from tab_sensor where mark = '雨量计') b on a.sensorname = b.name where a.jctime is null")
    List<DeviceOffLineInfoModel> findDeviceOffLineData();

    /**
     * 内部位移(水平)
     * @return
     */
    @Select("select c.sensorname AS sensorno, c.jctime AS collectdate, c.value2 as xvalue, 0 as yvalue, c.ifbj AS valuestate, b.id AS recordid from (" +
            " select a.id, a.sensorname, a.jctime, a.value2, a.ifbj from ("+
            " select id, sensorname, jctime, value2, ifbj, rank() over (partition by sensorname order by jctime desc)" +
            " from tab_shuipingweiyi where jctime > now() - interval '6 hour'" +
            " ) a where rank = 1" +
            " ) c  inner join (select id, name from tab_sensor) b on c.sensorname = b.name")
    List<NeibuweiyiRealTimeInfoModel> findNeibuShuipingRealTimeData();

    /**
     * 内部位移(沉降)
     * @return
     */
    @Select("select c.sensorname AS sensorno, c.jctime AS collectdate, c.value2 as yvalue, 0 as xvalue, c.ifbj AS valuestate, b.id AS recordid from (" +
            " select a.id, a.sensorname, a.jctime, a.value2, a.ifbj from (" +
            " select id, sensorname, jctime, value2, ifbj, rank() over (partition by sensorname order by jctime desc)" +
            " from tab_neibuchenjiang where jctime > now() - interval '6 hour'" +
            " ) a where rank = 1" +
            " ) c  inner join (select id, name from tab_sensor) b on c.sensorname = b.name")
    List<NeibuweiyiRealTimeInfoModel> findNeibuChenjiangRealTimeData();
}
